Developer Documentation

Public Slots | Signals | Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
MeshComparePlugin Class Reference
Inheritance diagram for MeshComparePlugin:

## Public Slots
QString | version ()

## Signals
void | updateView ()
void | updatedObject (int _id, const UpdateType &_type)
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
void | log (Logtype _type, QString _message)
void | log (QString _message)
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
void | createBackup (int _id, QString _name, UpdateType _type=UPDATE_ALL)
void | pluginExists (QString _pluginName, bool &_exists)
Signals inherited from BaseInterface
virtual void | updateView ()
| Update current view in Main Application. More...
virtual void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Set a description for a public slot. More...
virtual void | setRenderer (unsigned int _viewer, QString _rendererName)
| Set a renderer for the given viewer. More...
Signals inherited from ToolboxInterface
virtual void | addToolbox (QString _name, QWidget *_widget)
| Add a toolbox widget to the gui with the given name. More...
Signals inherited from LoggingInterface
virtual void | log (Logtype _type, QString _message)=0
virtual void | log (QString _message)=0
Signals inherited from ScriptInterface
virtual void | scriptInfo (QString _functionWithParameters)
| Emit this signal if a scriptable function is executed. More...
virtual void | getScriptingEngine (QScriptEngine *&_engine)
virtual void | executeScript (QString _script)
virtual void | getAvailableFunctions (QStringList &_functions)
Signals inherited from BackupInterface
virtual void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell Backup Plugin to create a backup. More...
virtual void | aboutToRestore (int _objectid)
| Backup Plugin tells other Plugins that a restore will happen. More...
virtual void | generateBackup (int _id, QString _name, UpdateType _type)
| This signal is emitted by a BackupPlugin and tells a TypePlugin to generate a backup. More...
Signals inherited from TextureInterface
virtual void | addTexture (QString _name, QString _filename, uint _dimension, int _id)
| Emit this Signal if a texture has been added (Property Name,filename,Dimension) More...
Signals inherited from RPCInterface
virtual void | pluginExists (QString _pluginName, bool &_exists)

## Public Member Functions
QString | name ()
| Return a name for the plugin. More...
QString | description ()
| Return a description of what the plugin is doing. More...
void | compare (int _sourceId, int _targetId, bool _computeDist=true, bool _computeNormal=true, bool _computeGauss=true, bool _computeMean=true)
double | lastMaximalDistance ()
| Get the maximal distance of the last comparison (-1, if no comparison performed so far)
double | lastMaximalNormalDeviation ()
| Get the maximal normal deviation of the last comparison in degree (-1, if no comparison performed so far)
double | lastMaximalMeanCurvatureDeviation ()
| Get the maximal mean curvature deviation of the last comparison (-1, if no comparison performed so far)
double | lastMaximalGaussCurvatureDeviation ()
| Get the maximal gauss curvature deviation of the last comparison (-1, if no comparison performed so far)

## Private Slots
void | initializePlugin ()
void | pluginsInitialized ()
void | compareButton ()
| Triggers comparison of the selected meshes.
void | slotClear ()
| Clears the visualization.
void | slotObjectUpdated (int _identifier, const UpdateType &_type)
| Called when an object gets updated.
void | noguiSupported ()
void | slotClampBox (bool _checked)
| If the checkbox is changed to be checked, the values in the labels will be written into the spin boxes.
Private Slots inherited from BaseInterface
virtual void | exit ()
virtual QString | version ()
| Return a version string for your plugin. More...

## Private Member Functions
void | visualizeData (const std::vector< double > &_data, double _maxValue, ACG::SceneGraph::PointNode *_pnode)
| Visualize data. More...
Private Member Functions inherited from BaseInterface
virtual void | noguiSupported ()
virtual | ~BaseInterface ()
| Destructor.
virtual void | blockScenegraphUpdates (bool _block)
| Tell the core to prevent scenegraph updates. More...
virtual void | updatedObject (int _objectId)
| An object has been changed or added by this plugin. More...
virtual void | updatedObject (int _identifier, const UpdateType &_type)
| An object has been changed or added by this plugin. More...
virtual void | nodeVisibilityChanged (int _identifier)
| A scenegraph node has been shown or hidden. More...
virtual void | getCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| Get the current renderer for the given viewer. More...
Private Member Functions inherited from ToolboxInterface
virtual | ~ToolboxInterface ()
| Destructor.
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
| Add a toolbox widget to the gui with the given name and an icon. More...
virtual void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon, QWidget *_headerAreaWidget)
| Add a toolbox widget to the gui with the given name, icon and header area widget. More...
Private Member Functions inherited from LoggingInterface
virtual | ~LoggingInterface ()
| Destructor.
Private Member Functions inherited from ScriptInterface
virtual | ~ScriptInterface ()
| Destructor.
virtual void | executeFileScript (QString _filename)
virtual void | getDescription (QString _function, QString &_description, QStringList &_parameters, QStringList &_descriptions)
Private Member Functions inherited from BackupInterface
virtual void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Tell Backup Plugin to create a group backup. More...
virtual void | undo (int _objectid)
| Tell Backup Plugin to undo the last action of an object. More...
virtual void | redo (int _objectid)
| Tell Backup Plugin to redo the last action on an object. More...
virtual void | undo ()
| Tell Backup Plugin to undo the last action. More...
virtual void | redo ()
| Tell Backup Plugin to redo the last action. More...
virtual | ~BackupInterface ()
| Destructor.
virtual void | restored (int _objectid)
| Backup Plugin tells other Plugins that a restore has happened. More...
Private Member Functions inherited from TextureInterface
virtual void | addTexture (QString _name, QImage _image, uint _dimension, int _id)
| Emit this Signal if a texture has been added (Property Name,image,Dimension) More...
virtual void | addTexture (QString _name, QString _filename, uint _dimension)
| Emit this Signal if a texture has been added (Property Name,filename,Dimension) More...
virtual void | addTexture (QString _name, QImage _image, uint _dimension)
| Emit this Signal if a texture has been added (Property Name,image,Dimension) More...
virtual void | addMultiTexture (QString _textureGroup, QString _name, QString _filename, int _id, int &_textureId)
| Emit this Signal if you want to add a texture for a multitexturing mode. More...
virtual void | addMultiTexture (QString _textureGroup, QString _name, QImage _image, int _id, int &_textureId)
| Emit this Signal if you want to add a texture for a multitexturing mode. More...
virtual void | updateTexture (QString _textureName, int _identifier)
| Tell Plugins to update the given texture for the given identifier This signal can be called from any thread. .
virtual void | updateAllTextures ()
| Tell Plugins to update all textures.
virtual void | updatedTextures (QString, int)
| emit this signal if you updated a texture More...
virtual void | switchTexture (QString _textureName, int _id)
| emit this signal if you want to switch the texture of a specific object This signal can be called from any thread.
virtual void | switchTexture (QString _textureName)
| emit this signal if you want to switch the global texture This signal can be called from any thread.
virtual void | setTextureMode (QString _textureName, QString _mode)
| emit this signal if you want to set a special mode for this texture (Clamping,...) More...
virtual void | setTextureMode (QString _textureName, QString _mode, int _id)
| emit this signal if you want to set a special mode for this texture (Clamping,...) More...
virtual void | textureChangeImage (QString _textureName, QImage &_image, int _id)
| Change the texture image of a given texture. More...
virtual void | textureChangeImage (QString _textureName, QImage &_image)
| Change the texture image of a given global texture. More...
virtual void | textureGetImage (QString _textureName, QImage &_image, int _id)
| get the texture image of a given texture More...
virtual void | textureGetImage (QString _textureName, QImage &_image)
| Get the texture image of a given global texture. More...
virtual void | textureIndex (QString _textureName, int _id, int &_index)
| Get the texture index of a given texture. More...
virtual void | textureIndexPropertyName (int _id, QString &_propertyName)
| Get the name of the texture index property. More...
virtual void | textureName (int _id, int _textureIndex, QString &_textureName)
| get the name of the texture with given texture index More...
virtual void | textureFilename (int _id, QString _textureName, QString &_textureFilename)
| get the filename of the texture with given texture index More...
virtual void | getCurrentTexture (int _id, QString &_textureName)
| get the name of the texture which is currently enabled More...
virtual void | getSubTextures (int _id, QString _multiTextureName, QStringList &_subTextures)
| get the names of all sub-textures under the given multiTexture More...
virtual | ~TextureInterface ()
| Destructor.
Private Member Functions inherited from RPCInterface
virtual | ~RPCInterface ()
| Destructor.
virtual void | functionExists (QString _pluginName, QString _functionName, bool &_exists)
Private Member Functions inherited from PythonInterface
virtual | ~PythonInterface ()
| Destructor.

## Private Attributes
MeshCompareToolbarWidget * | tool_
| The toolbar widget of this plugin.
double | maximalDistance_
| Last maximal computed distance.
double | maxNormalDeviation_
| Last maximal computed normal deviation in degree.
double | maxMeanCurvatureDev_
| Last maximal mean curvature deviation.
double | maxGaussCurvatureDev_
| Last maximal gauss curvature deviation.

## Detailed Description

Definition at line 68 of file MeshComparePlugin.hh.

## Member Function Documentation

## ◆ compare()

void MeshComparePlugin::compare | ( | int | _sourceId,
|  | int | _targetId,
|  | bool | _computeDist = `true`,
|  | bool | _computeNormal = `true`,
|  | bool | _computeGauss = `true`,
|  | bool | _computeMean = `true`
| ) |  |

Compares two meshes. Use the two getter functions to retrieve the maximal deviations.

The source will be the reference. The difference will be rendered as points on the target mesh.

Parameters

  _sourceId | Id of the reference mesh
  _targetId | Id of the mesh that should be compared to the reference mesh.
  _computeDist | Compute distance between meshes
  _computeNormal | Compute normal deviation between meshes
  _computeGauss | Compute gauss curvature deviation between meshes
  _computeMean | Compute mean curvature deviation between meshes

Definition at line 219 of file MeshComparePlugin.cc.

## ◆ description()

QString MeshComparePlugin::description | ( |  | ) |
| inline virtual

Return a description of what the plugin is doing.

This function has to return a basic description of the plugin

Implements BaseInterface.

Definition at line 109 of file MeshComparePlugin.hh.

## ◆ name()

QString MeshComparePlugin::name | ( |  | ) |
| inline virtual

Return a name for the plugin.

This Function has to return the name of the plugin.

Implements BaseInterface.

Definition at line 108 of file MeshComparePlugin.hh.

## ◆ visualizeData()

void MeshComparePlugin::visualizeData | ( | const std::vector< double > & | _data,
|  | double | _maxValue,
|  | ACG::SceneGraph::PointNode * | _pnode
| ) |  |
| private

Visualize data.

This function visualizes the data via rendering points and pushes it to the histogram.

Parameters

  _data | Vector of data points
  _maxValue | Maximal value found in the data
  _pnode | The point node that will be used to visualize the data

Definition at line 435 of file MeshComparePlugin.cc.

The documentation for this class was generated from the following files:

- Plugin-MeshCompare/MeshComparePlugin.hh
- Plugin-MeshCompare/MeshComparePlugin.cc